/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of SSH2.xs. Do not edit this file, edit SSH2.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "SSH2.xs"
/*
 * SSH2.xs - C functions for Net::SSH2
 *
 * D. Robins, 20051022
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <libssh2.h>
#include <libssh2_sftp.h>
#include <libssh2_publickey.h>


#include "const-c.inc"


/* constants */

#ifndef LIBSSH2_ERROR_NONE
#define LIBSSH2_ERROR_NONE 0
#endif  /* LIBSSH2_ERROR_NONE */

/* LIBSSH2_ERROR_* values; from 0 continuing negative */
const char* libssh2_error[] = {
    "NONE",
    "SOCKET_NONE",
    "BANNER_NONE",
    "BANNER_SEND",
    "INVALID_MAC",
    "KEX_FAILURE",
    "ALLOC",
    "SOCKET_SEND",
    "KEY_EXCHANGE_FAILURE",
    "TIMEOUT",
    "HOSTKEY_INIT",
    "HOSTKEY_SIGN",
    "DECRYPT",
    "SOCKET_DISCONNECT",
    "PROTO",
    "PASSWORD_EXPIRED",
    "FILE",
    "METHOD_NONE",
    "PUBLICKEY_UNRECOGNIZED",
    "PUBLICKEY_UNVERIFIED",
    "CHANNEL_OUTOFORDER",
    "CHANNEL_FAILURE",
    "CHANNEL_REQUEST_DENIED",
    "CHANNEL_UNKNOWN",
    "CHANNEL_WINDOW_EXCEEDED",
    "CHANNEL_PACKET_EXCEEDED",
    "CHANNEL_CLOSED",
    "CHANNEL_EOF_SENT",
    "SCP_PROTOCOL",
    "ZLIB",
    "SOCKET_TIMEOUT",
    "SFTP_PROTOCOL",
    "REQUEST_DENIED",
    "METHOD_NOT_SUPPORTED",
    "INVAL",
    "INVALID_POLL_TYPE",
	"PUBLICKEY_PROTOCOL",
    "EAGAIN"
};

/* SSH_FX_* values; from 0 continuing positive */
const char* sftp_error[] = {
    "OK",
    "EOF",
    "NO_SUCH_FILE",
    "PERMISSION_DENIED",
    "FAILURE",
    "BAD_MESSAGE",
    "NO_CONNECTION",
    "CONNECTION_LOST",
    "OP_UNSUPPORTED",
    "INVALID_HANDLE",
    "NO_SUCH_PATH",
    "FILE_ALREADY_EXISTS",
    "WRITE_PROTECT",
    "NO_MEDIA",
    "NO_SPACE_ON_FILESYSTEM",
    "QUOTA_EXCEEDED",
    "UNKNOWN_PRINCIPLE",
    "LOCK_CONFLICT",
    "DIR_NOT_EMPTY",
    "NOT_A_DIRECTORY",
    "INVALID_FILENAME",
    "LINK_LOOP"
};

/* private internal functions */

#define countof(x) (sizeof(x)/sizeof(*x))

#define XLATEXT (ext ? SSH_EXTENDED_DATA_STDERR : 0)

#define XLATATTR(name, field, flag) \
    else if (strEQ(key, name)) { \
        attrs.field = SvUV(ST(i + 1)); \
        attrs.flags |= LIBSSH2_SFTP_ATTR_##flag; \
    }

/* Net::SSH2 object */
typedef struct SSH2 {
    LIBSSH2_SESSION* session;
    SV* sv_ss;  /* NB: not set until callback() called */
    SV* socket;
    SV* sv_tmp;
    int errcode;
    SV* errmsg;
    SV* rgsv_cb[LIBSSH2_CALLBACK_X11 + 1];
} SSH2;

/* Net::SSH2::Channel object */
typedef struct SSH2_CHANNEL {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_CHANNEL* channel;
} SSH2_CHANNEL;

/* Net::SSH2::SFTP object */
typedef struct SSH2_SFTP {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_SFTP* sftp;
} SSH2_SFTP;

/* Net::SSH2::Listener object */
typedef struct SSH2_LISTENER {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_LISTENER* listener;
} SSH2_LISTENER;

/* Net::SSH2::File object */
typedef struct SSH2_FILE {
    SSH2_SFTP* sf;
    SV* sv_sf;
    LIBSSH2_SFTP_HANDLE* handle;
} SSH2_FILE;

/* Net::SSH2::Dir object */
typedef struct SSH2_DIR {
    SSH2_SFTP* sf;
    SV* sv_sf;
    LIBSSH2_SFTP_HANDLE* handle;
} SSH2_DIR;

/* Net::SSH2::PublicKey object */
typedef struct SSH2_PUBLICKEY {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_PUBLICKEY* pkey;
} SSH2_PUBLICKEY;

static int net_ss_debug_out = 0;
static unsigned long net_ch_gensym = 0;
static unsigned long net_fi_gensym = 0;

/* debug output */
static void debug(const char* format, ...) {
    if (net_ss_debug_out) {
        va_list va;
        va_start(va, format);
        vwarn(format, &va);
        va_end(va);
    }
}

/* libssh2 allocator thunks */
LIBSSH2_ALLOC_FUNC(local_alloc) {
    return Perl_malloc(count);
}
LIBSSH2_REALLOC_FUNC(local_realloc) {
    return Perl_realloc(ptr, count);
}
LIBSSH2_FREE_FUNC(local_free) {
    Perl_mfree(ptr);
}

/* set Net:SSH2-specific error message */
static void set_error(SSH2* ss, int errcode, const char* errmsg) {
    ss->errcode = errcode;
    if (ss->errmsg)
        SvREFCNT_dec(ss->errmsg);
    ss->errmsg = errmsg ? newSVpv(errmsg, 0) : NULL;
}    

/* clear our local error flag */
static void clear_error(SSH2* ss) {
    set_error(ss, LIBSSH2_ERROR_NONE, NULL/*errmsg*/);
}

/* split a string at commas and push each substring onto the perl stack */
static int split_comma(SV** sp, const char* str) {
    int i;
    const char* p;

    if (!str || !*str)
        return 0;

    i = 1;
    while ((p = strchr(str, ','))) {
        mXPUSHp(str, p - str);
        str = p + 1;
        ++i;
    }
    mXPUSHp(str, strlen(str));
    return i;
}

/* push a hash of values onto the return stack, for '%hash = func()' */
static int push_hv(SV** sp, HV* hv) {
    I32 keys = hv_iterinit(hv);
    const char* pv_key;
    I32 len_key;
    SV* value;

    EXTEND(SP, keys * 2);
    while ((value = hv_iternextsv(hv, (char**)&pv_key, &len_key))) {
        PUSHs(sv_2mortal(newSVpvn(pv_key, len_key)));
        PUSHs(sv_2mortal(SvREFCNT_inc(value)));
    }
    SvREFCNT_dec(hv);
    return keys * 2;
}

/* return NULL if undef or NULL, else return string */
static const char* default_string(SV* sv) {
    return (sv && SvPOK(sv)) ? SvPV_nolen(sv) : NULL;
}

/* return an integer constant from an SV name or value */
static int iv_constant_sv(const char *prefix, SV* c_sv, IV* piv) {
    int ret = 1;

    /* accept type as constant, constant without prefix, or numeric value */
    if (SvIOK(c_sv)) {
        *piv = SvIV(c_sv);
    } else {
        SV *sv = newSVsv(c_sv);
        char* str = SvPV_nolen(sv), * p;
        const char* pv;
        STRLEN len = strlen(prefix);

        for (p = str; *p; ++p)
            *p = toUPPER(*p);
        if (strncmp(str, prefix, len))
            sv_insert(sv, 0/*offset*/, 0/*replace*/, (char*)prefix, len);
        pv = SvPV(sv, len);
	    if (constant(aTHX_ pv, len, piv) != PERL_constant_ISIV)
            ret = 0;
        SvREFCNT_dec(sv);
    }
    return ret;
}

/* create a hash from an SFTP attributes structure */
static HV* hv_from_attrs(LIBSSH2_SFTP_ATTRIBUTES* attrs) {
    HV* hv = newHV();
    debug("hv_from_attrs: attrs->flags = %d\n", attrs->flags);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_SIZE)
        hv_store(hv, "size", 4, newSVuv(attrs->filesize), 0/*hash*/);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_UIDGID) {
        hv_store(hv, "uid", 3, newSVuv(attrs->uid), 0/*hash*/);
        hv_store(hv, "gid", 3, newSVuv(attrs->gid), 0/*hash*/);
    }
    if (attrs->flags & LIBSSH2_SFTP_ATTR_PERMISSIONS)
        hv_store(hv, "mode", 4, newSVuv(attrs->permissions), 0/*hash*/);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_ACMODTIME) {
        hv_store(hv, "atime", 5, newSVuv(attrs->atime), 0/*hash*/);
        hv_store(hv, "mtime", 5, newSVuv(attrs->mtime), 0/*hash*/);
    }
    return hv;
}

/* return attributes from function, as flat hash or hashref */
#define XSRETURN_STAT_ATTRS(name) XSRETURN(return_stat_attrs(sp, &attrs, name))
    
static int return_stat_attrs(SV** sp, LIBSSH2_SFTP_ATTRIBUTES* attrs,
 SV* name) {
    HV* hv_attrs = hv_from_attrs(attrs);
    if (name)
        hv_store(hv_attrs, "name", 4, name, 0/*hash*/);

    switch (GIMME_V) {
    case G_SCALAR:
        PUSHs(sv_2mortal(newRV_noinc((SV*)hv_attrs)));
        return 1;
    case G_ARRAY:
        return push_hv(sp, hv_attrs);
    default:
        SvREFCNT_dec(hv_attrs);
    }
    return 0;
}

/* general wrapper */
#define NEW_ITEM(type, field, create, parent) do { \
    Newz(0/*id*/, RETVAL, 1, type); \
    if (RETVAL) { \
        RETVAL->parent = parent; \
        RETVAL->sv_##parent = SvREFCNT_inc(SvRV(ST(0))); \
        RETVAL->field = create; \
        debug(#create " -> 0x%p\n", RETVAL->field); \
    } \
    if (!RETVAL || !RETVAL->field) { \
        if (RETVAL) \
            SvREFCNT_dec(RETVAL->sv_##parent); \
        Safefree(RETVAL); \
        XSRETURN_EMPTY; \
    } \
} while(0)

/* wrap a libSSH2 channel */
#define NEW_CHANNEL(create) NEW_ITEM(SSH2_CHANNEL, channel, create, ss)

/* wrap a libSSH2 listener */
#define NEW_LISTENER(create) NEW_ITEM(SSH2_LISTENER, listener, create, ss)

/* wrap a libSSH2 SFTP connection */
#define NEW_SFTP(create) NEW_ITEM(SSH2_SFTP, sftp, create, ss)

/* wrap a libSSH2 SFTP file */
#define NEW_FILE(create) NEW_ITEM(SSH2_FILE, handle, create, sf)

/* wrap a libSSH2 SFTP directory */
#define NEW_DIR(create) NEW_ITEM(SSH2_DIR, handle, create, sf)

/* wrap a libSSH2 public key object */
#define NEW_PUBLICKEY(create) NEW_ITEM(SSH2_PUBLICKEY, pkey, create, ss)

/* callback for returning a password via "keyboard-interactive" auth */
static LIBSSH2_USERAUTH_KBDINT_RESPONSE_FUNC(cb_kbdint_response_password) {
    SSH2* ss = (SSH2*)*abstract;
    const char* pv_password;
    STRLEN len_password;

    if (num_prompts != 1 || prompts[0].echo) {
        int i;
        for (i = 0; i < num_prompts; ++i)
            responses[i].length = 0;
        return;
     }

    /* single prompt, no echo: assume it's a password request */
    pv_password = SvPV(ss->sv_tmp, len_password);
    responses[0].text = Perl_malloc(len_password);
    memcpy(responses[0].text, pv_password, len_password);
    responses[0].length = len_password;
}

/* thunk to call perl input-reading function for "keyboard-interactive" auth */
static LIBSSH2_USERAUTH_KBDINT_RESPONSE_FUNC(cb_kbdint_response_callback) {
    SSH2* ss = (SSH2*)*abstract;
    int i;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    EXTEND(SP, 4 + num_prompts);
    PUSHs(*av_fetch((AV*)ss->sv_tmp, 1, 0/*lval*/));
    PUSHs(*av_fetch((AV*)ss->sv_tmp, 2, 0/*lval*/));
    PUSHs(sv_2mortal(newSVpvn(name, name_len)));
    PUSHs(sv_2mortal(newSVpvn(instruction, instruction_len)));
    for (i = 0; i < num_prompts; ++i) {
        HV* hv = newHV();
        responses[i].length = 0;
        hv_store(hv, "text", 4, newSVpvn(prompts[i].text, prompts[i].length),
         0/*hash*/);
        hv_store(hv, "echo", 4, newSViv(prompts[i].echo), 0/*hash*/);
        PUSHs(sv_2mortal(newRV_noinc((SV*)hv)));
    }
    PUTBACK;

    count = call_sv(*av_fetch((AV*)ss->sv_tmp, 0, 0/*lval*/), G_ARRAY);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    /* translate the returned responses */
    for (i = 0; i < count; ++i) {
        STRLEN len_response;
        const char* pv_response = SvPV(ST(i), len_response);
        responses[i].text = Perl_malloc(len_response);
        memcpy(responses[i].text, pv_response, len_response);
        responses[i].length = len_response;
    }

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl password change function for "password" auth */
static LIBSSH2_PASSWD_CHANGEREQ_FUNC(cb_password_change_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(*av_fetch((AV*)ss->sv_tmp, 1, 0/*lval*/));
    XPUSHs(*av_fetch((AV*)ss->sv_tmp, 2, 0/*lval*/));
    PUTBACK;

    *newpw = NULL;
    *newpw_len = 0;
    count = call_sv(*av_fetch((AV*)ss->sv_tmp, 0, 0/*lval*/), G_SCALAR);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    if (count > 0) {
        STRLEN len_password;
        const char* pv_password = SvPV(ST(0), len_password);
        *newpw = Perl_malloc(len_password);
        memcpy(*newpw, pv_password, len_password);
        *newpw_len = len_password;
    }

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_IGNORE packet function */
static LIBSSH2_IGNORE_FUNC(cb_ignore_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHp(message, message_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_IGNORE], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_DEBUG packet function */
static LIBSSH2_DEBUG_FUNC(cb_debug_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHi(always_display);
    mXPUSHp(message, message_len);
    mXPUSHp(language, language_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_DEBUG], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_DISCONNECT packet function */
static LIBSSH2_DISCONNECT_FUNC(cb_disconnect_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHi(reason);
    mXPUSHp(message, message_len);
    mXPUSHp(language, language_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_DISCONNECT], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_MACERROR packet function */
static LIBSSH2_MACERROR_FUNC(cb_macerror_callback) {
    SSH2* ss = (SSH2*)*abstract;
    int ret = 0;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHp(packet, packet_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_MACERROR], G_SCALAR);
    SPAGAIN; SP -= count ; ax = (SP - PL_stack_base) + 1;

    if (count > 0)
        ret = SvIV(ST(0));
 
    PUTBACK; FREETMPS; LEAVE;
    return ret;
}

/* thunk to call perl X11 forwarder packet function */
static LIBSSH2_X11_OPEN_FUNC(cb_x11_open_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    /*TODO: we actually need to push a channel here, but we don't know the
     *      SV of the channel (use a local hash?) */
    XPUSHs(&PL_sv_undef);
    mXPUSHp(shost, strlen(shost));
    mXPUSHi(sport);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_X11], G_VOID);
    SPAGAIN; SP -= count ; ax = (SP - PL_stack_base) + 1 ;

    PUTBACK; FREETMPS; LEAVE;
}

static void (*msg_cb[])() = {
    (void (*)())cb_ignore_callback,
    (void (*)())cb_debug_callback,
    (void (*)())cb_disconnect_callback,
    (void (*)())cb_macerror_callback,
    (void (*)())cb_x11_open_callback
};


/* perl module exports */

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 538 "SSH2.c"

/* INCLUDE:  Including 'const-xs.inc' from 'SSH2.xs' */


XS(XS_Net__SSH2_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_constant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::constant", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 568 "SSH2.c"
	SV *	sv = ST(0);
	const char *	s = SvPV(sv, len);
#line 18 "const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Net::SSH2 macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Net::SSH2 macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Net::SSH2 macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 645 "SSH2.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'SSH2.xs' from 'const-xs.inc' */

#define class "Net::SSH2"

XS(XS_Net__SSH2_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::new", "SV*");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2 *	RETVAL;
#line 534 "SSH2.xs"
    Newz(0/*id*/, RETVAL, 1, SSH2);
    if (RETVAL) {
        RETVAL->session = libssh2_session_init_ex(
         local_alloc, local_free, local_realloc, RETVAL);
    }
    if (!RETVAL || !RETVAL->session) {
        Safefree(RETVAL);
        XSRETURN_EMPTY;
    }
    clear_error(RETVAL);
    /*libssh2_trace(RETVAL->session, -1);*/  /* enable tracing if debug build */
    debug("Net::SSH2: created new object 0x%x\n", RETVAL);
#line 682 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2_blocking); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_blocking)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::blocking", "ss, blocking");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2*	ss;
	SV*	blocking = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_blocking() - invalid session object");
#line 552 "SSH2.xs"
    clear_error(ss);
    libssh2_session_set_blocking(ss->session, SvTRUE(blocking));
    XSRETURN_IV(1);
#line 714 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::DESTROY", "ss");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_DESTROY() - invalid session object");
#line 559 "SSH2.xs"
    debug("%s::DESTROY object 0x%x\n", class, ss);
    clear_error(ss);
    libssh2_session_free(ss->session);
    SvREFCNT_dec(ss->socket);
    Safefree(ss);
#line 744 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_debug); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_debug)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::debug", "SV*, debug");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV*	debug = ST(1);
#line 568 "SSH2.xs"
    net_ss_debug_out = SvIV(debug) & 1;  /* allow for future flags */
#line 765 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::version", "name= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV*	name;

	if (items < 1)
	    name = NULL;
	else {
	    name = ST(0);
	}
#line 573 "SSH2.xs"
    switch (GIMME_V) {
    case G_SCALAR:
        XSRETURN_PV(LIBSSH2_VERSION);
    case G_ARRAY:
        EXTEND(SP, 3);
        ST(0) = sv_2mortal(newSVpv(LIBSSH2_VERSION, 0));
        ST(1) = sv_2mortal(newSVuv(LIBSSH2_VERSION_NUM));
        ST(2) = sv_2mortal(newSVpv(LIBSSH2_SSH_DEFAULT_BANNER, 0));
        XSRETURN(3);
    }
#line 801 "SSH2.c"
    }
    XSRETURN(1);
}


XS(XS_Net__SSH2_banner); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_banner)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::banner", "ss, banner");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 587 "SSH2.xs"
    int success;
    SV* sv_banner;
#line 822 "SSH2.c"
	SSH2*	ss;
	SV*	banner = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_banner() - invalid session object");
#line 590 "SSH2.xs"
    clear_error(ss);
    sv_banner = newSVsv(banner);
    sv_insert(sv_banner, 0/*offset*/, 0/*len*/, "SSH-2.0-", 8);
    success = !libssh2_banner_set(ss->session, SvPV_nolen(sv_banner));
    SvREFCNT_dec(sv_banner);
    XSRETURN_IV(success);
#line 837 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::error", "ss, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 600 "SSH2.xs"
    SV* errmsg;
    int errcode;
#line 858 "SSH2.c"
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_error() - invalid session object");
#line 603 "SSH2.xs"
    if (items == 3) {
        set_error(ss, SvIV(ST(1)), SvPV_nolen(ST(2)));
        XSRETURN_EMPTY;
    } else if(items != 1)
        croak("%s::error: too many arguments", class);

    /* if we have a local error, take it, else use libSSH2's value */
    if (ss->errcode != LIBSSH2_ERROR_NONE && ss->errmsg != NULL) {
        errcode = ss->errcode;
        errmsg = SvREFCNT_inc(ss->errmsg);
    } else {
        char* errstr;
        int errlen;
        errcode = libssh2_session_last_error(
         ss->session, &errstr, &errlen, 0/*want_buf*/);
        errmsg = errstr ? newSVpvn(errstr, errlen) : NULL;
    }

    if (errcode == LIBSSH2_ERROR_NONE && errmsg == NULL)
        XSRETURN_EMPTY;
    switch (GIMME_V) {
    case G_SCALAR:
        XSRETURN_IV(errcode);
    case G_ARRAY: {
        SV* code;
        EXTEND(SP, 3);
        ST(0) = sv_2mortal(newSViv(errcode));
        if (errcode < 0) {
            code = (-errcode < countof(libssh2_error)) ? 
             newSVpvf("LIBSSH2_ERROR_%s", libssh2_error[-errcode]) :
             newSVpvf("LIBSSH2_ERROR_UNKNOWN(%d)", errcode);
        } else if(errcode > 0)
            code = newSVpv(Strerror(errcode), 0);
        else
            code = newSVpvn("", 0);  /* possibly set via set_error */
        ST(1) = sv_2mortal(code);
        ST(2) = sv_2mortal(errmsg);
        XSRETURN(3);
    }
    }
#line 906 "SSH2.c"
    }
    XSRETURN(1);
}


XS(XS_Net__SSH2_method); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_method)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::method", "ss, method_type, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 647 "SSH2.xs"
    IV type;
    int i;
    SV* prefs;
    STRLEN len;
#line 931 "SSH2.c"
	SSH2*	ss;
	SV*	method_type = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_method() - invalid session object");
#line 652 "SSH2.xs"
    clear_error(ss);
    if (!iv_constant_sv("LIBSSH2_METHOD_", method_type, &type))
        croak("%s::method: unknown method type: %s",
         class, SvPV_nolen(method_type));

    /* if there are no other parameters, return the current value */
    if (items <= 2) {
        const char *method = libssh2_session_methods(ss->session, (int)type);
        if (!method)
            XSRETURN_EMPTY;
        XSRETURN_PV(method);
    }

    /* accept prefs as a string or multiple strings, joining with "," */
    prefs = newSVpvn("", 0);
    for (i = 2; i < items; ++i) {
        const char* pv_pref;
        if (i > 2)
            sv_catpvn(prefs, ",", 1);
        pv_pref = SvPV(ST(i), len);
        sv_catpvn(prefs, pv_pref, len);
    }

    /* call and clean up */
    i = libssh2_session_method_pref(ss->session,
     (int)type, SvPV_nolen(prefs));
    SvREFCNT_dec(prefs);
    XSRETURN_IV(!i);
#line 968 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__SSH2_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_callback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::callback", "ss, type, callback= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 684 "SSH2.xs"
    IV i_type;
#line 989 "SSH2.c"
	SSH2*	ss;
	SV*	type = ST(1);
	SV*	callback;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_callback() - invalid session object");

	if (items < 3)
	    callback = NULL;
	else {
	    callback = ST(2);
	}
#line 686 "SSH2.xs"
    clear_error(ss);
    if (callback && !SvOK(callback))
        callback = NULL;
    if (callback && !(SvROK(callback) && SvTYPE(SvRV(callback)) == SVt_PVCV))
        croak("%s::callback: callback must be CODE ref", class);
    if (!iv_constant_sv("LIBSSH2_CALLBACK_", type, &i_type))
        croak("%s::callback: invalid callback type: %s",
         class, SvPV_nolen(callback));
    if (i_type < 0 || i_type >= countof(msg_cb))
        croak("%s::callback: don't know how to handle: %s",
         class, SvPV_nolen(callback));

    ss->sv_ss = SvRV(ST(0));  /* don't keep a reference, just store it */
    SvREFCNT_dec(ss->rgsv_cb[i_type]);
    libssh2_session_callback_set(ss->session,
     i_type, callback ? msg_cb[i_type] : NULL);
    SvREFCNT_inc(callback);
    ss->rgsv_cb[i_type] = callback;
    XSRETURN_IV(1);
#line 1024 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__startup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__startup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::_startup", "ss, socket, store");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 709 "SSH2.xs"
    int success;
#line 1044 "SSH2.c"
	SSH2*	ss;
	int	socket = (int)SvIV(ST(1));
	SV *	store = ST(2);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__startup() - invalid session object");
#line 711 "SSH2.xs"
    clear_error(ss);
    success = !libssh2_session_startup(ss->session, socket);
    if (success && store)
        ss->socket = SvREFCNT_inc(SvRV(store));
    XSRETURN_IV(success);
#line 1059 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_disconnect); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_disconnect)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::disconnect", "ss, description= \"\", reason= SSH_DISCONNECT_BY_APPLICATION, lang= \"\"");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2*	ss;
	const char*	description;
	int	reason;
	const char *	lang;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_disconnect() - invalid session object");

	if (items < 2)
	    description = "";
	else {
    description = (const char *)SvPV_nolen(ST(1));
	}

	if (items < 3)
	    reason = SSH_DISCONNECT_BY_APPLICATION;
	else {
	    reason = (int)SvIV(ST(2));
	}

	if (items < 4)
	    lang = "";
	else {
    lang = (const char *)SvPV_nolen(ST(3));
	}
#line 721 "SSH2.xs"
    clear_error(ss);
    XSRETURN_IV(!libssh2_session_disconnect_ex(
     ss->session, reason, description, lang));
#line 1108 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_hostkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_hostkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::hostkey", "ss, hash_type");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 728 "SSH2.xs"
    IV type;
    const char* hash;
    static STRLEN rglen[] = { 16/*MD5*/, 20/*SHA1*/ };
#line 1132 "SSH2.c"
	SSH2*	ss;
	SV*	hash_type = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_hostkey() - invalid session object");
#line 732 "SSH2.xs"
    clear_error(ss);
    if (!iv_constant_sv("LIBSSH2_HOSTKEY_HASH_", hash_type, &type) ||
     type < 1 || type > countof(rglen)) {
        croak("%s::hostkey: unknown hostkey hash: %s",
         class, SvPV_nolen(hash_type));
    }
    if ((hash = (const char*)libssh2_hostkey_hash(ss->session, type))) {
        PUSHs(sv_2mortal(newSVpvn(hash, rglen[type-1])));
        XSRETURN(1);
    }
    XSRETURN_EMPTY;
#line 1152 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__SSH2_auth_list); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_auth_list)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::auth_list", "ss, username= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 747 "SSH2.xs"
    const char* pv_username = NULL;
    char* auth;
    STRLEN len_username = 0;
    int count = 1;
#line 1178 "SSH2.c"
	SSH2*	ss;
	SV*	username;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_list() - invalid session object");

	if (items < 2)
	    username = NULL;
	else {
	    username = ST(1);
	}
#line 752 "SSH2.xs"
    clear_error(ss);
    if (username && SvPOK(username))
        pv_username = SvPV(username, len_username);
    auth = libssh2_userauth_list(ss->session, pv_username, len_username);
    if (!auth)
        XSRETURN_EMPTY;
    if (GIMME_V == G_ARRAY)
        count = split_comma(sp, auth);
    else
        PUSHs(sv_2mortal(newSVpv(auth, 0)));
    Perl_mfree(auth);
    XSRETURN(count);
#line 1205 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__SSH2_auth_ok); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_auth_ok)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::auth_ok", "ss");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_ok() - invalid session object");
#line 768 "SSH2.xs"
    clear_error(ss);
    XSRETURN_IV(libssh2_userauth_authenticated(ss->session));
#line 1233 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_auth_password); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_auth_password)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::auth_password", "ss, username, password= NULL, callback= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 775 "SSH2.xs"
    STRLEN len_username, len_password;
    const char* pv_username, * pv_password;
    int i;
#line 1255 "SSH2.c"
	SSH2*	ss;
	SV*	username = ST(1);
	SV*	password;
	SV*	callback;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_password() - invalid session object");

	if (items < 3)
	    password = NULL;
	else {
	    password = ST(2);
	}

	if (items < 4)
	    callback = NULL;
	else {
	    callback = ST(3);
	}
#line 779 "SSH2.xs"
    clear_error(ss);
    if (callback && SvOK(callback) &&
     !(SvROK(callback) && SvTYPE(SvRV(callback)) == SVt_PVCV))
        croak("%s::auth_password: callback must be CODE ref", class);
    pv_username = SvPV(username, len_username);

    /* if we don't have a password, try for an unauthenticated login */
    if (!password || !SvPOK(password)) {
        char* auth = libssh2_userauth_list(ss->session,
         pv_username, len_username);
        Perl_mfree(auth);
        XSRETURN_IV(!auth && libssh2_userauth_authenticated(ss->session));
    }

    /* if we have a callback, setup its parameters */
    if (callback) {
        SV* rgsv[] = { callback, ST(0), username }; /* callback, params... */
        for (i = 0; i < countof(rgsv); ++i)
            SvREFCNT_inc(rgsv[i]);
        ss->sv_tmp = (SV*)av_make(countof(rgsv), rgsv);
    }

    pv_password = SvPV(password, len_password);
    XSRETURN_IV(!libssh2_userauth_password_ex(ss->session, pv_username,
     len_username, pv_password, len_password,
     callback ? cb_password_change_callback : NULL));

    if (callback) {
        SvREFCNT_dec(ss->sv_tmp);
        ss->sv_tmp = NULL;
    }
#line 1309 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_auth_publickey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_auth_publickey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::auth_publickey", "ss, username, publickey, privatekey, passphrase= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 815 "SSH2.xs"
    const char* pv_username;
    STRLEN len_username;
#line 1330 "SSH2.c"
	SSH2*	ss;
	SV*	username = ST(1);
	const char*    publickey = (const char *)SvPV_nolen(ST(2));
	const char*    privatekey = (const char *)SvPV_nolen(ST(3));
	SV*	passphrase;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_publickey() - invalid session object");

	if (items < 5)
	    passphrase = NULL;
	else {
	    passphrase = ST(4);
	}
#line 818 "SSH2.xs"
    clear_error(ss);
    pv_username = SvPV(username, len_username);
    XSRETURN_IV(!libssh2_userauth_publickey_fromfile_ex(ss->session,
     pv_username, len_username, publickey, privatekey,
     default_string(passphrase)));
#line 1353 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_auth_hostbased); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_auth_hostbased)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::auth_hostbased", "ss, username, publickey, privatekey, hostname, local_username= NULL, passphrase= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 829 "SSH2.xs"
    const char* pv_username, * pv_hostname, * pv_local_username;
    STRLEN len_username, len_hostname, len_local_username;
#line 1374 "SSH2.c"
	SSH2*	ss;
	SV*	username = ST(1);
	const char*    publickey = (const char *)SvPV_nolen(ST(2));
	const char*    privatekey = (const char *)SvPV_nolen(ST(3));
	SV*	hostname = ST(4);
	SV*	local_username;
	SV*	passphrase;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_hostbased() - invalid session object");

	if (items < 6)
	    local_username = NULL;
	else {
	    local_username = ST(5);
	}

	if (items < 7)
	    passphrase = NULL;
	else {
	    passphrase = ST(6);
	}
#line 832 "SSH2.xs"
    clear_error(ss);
    pv_username = SvPV(username, len_username);
    pv_hostname = SvPV(hostname, len_hostname);

    if (!local_username || !SvPOK(local_username)) {
        pv_local_username = pv_username;
        len_local_username = len_username;
    } else
        pv_local_username = SvPV(local_username, len_local_username);

    XSRETURN_IV(!libssh2_userauth_hostbased_fromfile_ex(ss->session,
     pv_username, len_username, publickey, privatekey,
     default_string(passphrase),
     pv_hostname, len_hostname, pv_local_username, len_local_username));
#line 1414 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_auth_keyboard); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_auth_keyboard)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::auth_keyboard", "ss, username, password= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 850 "SSH2.xs"
    const char* pv_username;
    STRLEN len_username;
    int success;
#line 1436 "SSH2.c"
	SSH2*	ss;
	SV*	username = ST(1);
	SV*	password;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_keyboard() - invalid session object");

	if (items < 3)
	    password = NULL;
	else {
	    password = ST(2);
	}
#line 854 "SSH2.xs"
    clear_error(ss);
    pv_username = SvPV(username, len_username);

    /* we either have a password, or a reference to a callback */
    if (password && SvPOK(password)) {
        ss->sv_tmp = password;
        success = !libssh2_userauth_keyboard_interactive_ex(
         ss->session, pv_username, len_username, cb_kbdint_response_password);
        ss->sv_tmp = NULL;
        XSRETURN_IV(success);
    }

    /* alright, reference to callback it is */
    if (!password || !SvOK(password))
        password = sv_2mortal(newRV_noinc((SV*)get_cv(
         "Net::SSH2::_cb_kbdint_response_default", 0/*create*/)));
    if (!SvROK(password) || SvTYPE(SvRV(password)) != SVt_PVCV)
        croak("%s::auth_keyboard requires password or CODE ref", class);

    /* set up parameters for callback */
    {
        SV* rgsv[3];  /* callback, params... */
        int i;

			 	rgsv[0] = password;
				rgsv[1] = ST(0);
				rgsv[2] = username;

        for (i = 0; i < countof(rgsv); ++i)
            SvREFCNT_inc(rgsv[i]);
        ss->sv_tmp = (SV*)av_make(countof(rgsv), rgsv);
    }
    SvREFCNT_inc(SvRV(password));

    success = !libssh2_userauth_keyboard_interactive_ex(
     ss->session, pv_username, len_username, cb_kbdint_response_callback);

    SvREFCNT_dec(SvRV(password));
    SvREFCNT_dec(ss->sv_tmp);
    ss->sv_tmp = NULL;
    XSRETURN_IV(success);
#line 1493 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_channel); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_channel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::channel", "ss, channel_type= NULL, window_size= LIBSSH2_CHANNEL_WINDOW_DEFAULT, packet_size= LIBSSH2_CHANNEL_PACKET_DEFAULT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 901 "SSH2.xs"
    const char* pv_channel_type;
    STRLEN len_channel_type;
#line 1514 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	SV*	channel_type;
	int	window_size;
	int	packet_size;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_channel() - invalid session object");

	if (items < 2)
	    channel_type = NULL;
	else {
	    channel_type = ST(1);
	}

	if (items < 3)
	    window_size = LIBSSH2_CHANNEL_WINDOW_DEFAULT;
	else {
	    window_size = (int)SvIV(ST(2));
	}

	if (items < 4)
	    packet_size = LIBSSH2_CHANNEL_PACKET_DEFAULT;
	else {
	    packet_size = (int)SvIV(ST(3));
	}
#line 904 "SSH2.xs"
    clear_error(ss);
    if (channel_type)
        pv_channel_type = SvPV(channel_type, len_channel_type);
    else {
        pv_channel_type = "session";
        len_channel_type = 7;
    }

    NEW_CHANNEL(libssh2_channel_open_ex(ss->session,
     pv_channel_type, len_channel_type, window_size, packet_size,
     NULL/*message*/, 0/*message_len*/));
#line 1555 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__scp_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__scp_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::_scp_get", "ss, path, stat= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 921 "SSH2.xs"
    struct stat st;
#line 1589 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	const char*    path = (const char *)SvPV_nolen(ST(1));
	HV*	stat;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__scp_get() - invalid session object");

	if (items < 3)
	    stat = NULL;
	else {
	    if (SvROK(ST(2)) && SvTYPE(SvRV(ST(2)))==SVt_PVHV)
		stat = (HV*)SvRV(ST(2));
	    else
		Perl_croak(aTHX_ "%s: %s is not a hash reference",
			    "Net::SSH2::_scp_get",
			    "stat");
	}
#line 923 "SSH2.xs"
    clear_error(ss);
    NEW_CHANNEL(libssh2_scp_recv(ss->session, path, &st));
    if (stat) {
        hv_clear(stat);
        hv_store(stat, "mode",  4, newSVuv(st.st_mode),  0/*hash*/);
        hv_store(stat, "uid",   3, newSVuv(st.st_uid),   0/*hash*/);
        hv_store(stat, "gid",   3, newSVuv(st.st_gid),   0/*hash*/);
        hv_store(stat, "size",  4, newSVuv(st.st_size),  0/*hash*/);
        hv_store(stat, "atime", 5, newSVuv((time_t)st.st_atime), 0/*hash*/);
        hv_store(stat, "mtime", 5, newSViv((time_t)st.st_mtime), 0/*hash*/);
    }
#line 1622 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__scp_put); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__scp_put)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::_scp_put", "ss, path, mode, size, mtime= 0, atime= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	const char*    path = (const char *)SvPV_nolen(ST(1));
	int	mode = (int)SvIV(ST(2));
	size_t	size = (size_t)SvUV(ST(3));
	long	mtime;
	long	atime;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__scp_put() - invalid session object");

	if (items < 5)
	    mtime = 0;
	else {
	    mtime = (long)SvIV(ST(4));
	}

	if (items < 6)
	    atime = 0;
	else {
	    atime = (long)SvIV(ST(5));
	}
#line 941 "SSH2.xs"
    clear_error(ss);
    NEW_CHANNEL(libssh2_scp_send_ex(ss->session,
     path, mode, size, mtime, atime));
#line 1682 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2_tcpip); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_tcpip)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::tcpip", "ss, host, port, shost= NULL, sport= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	const char*    host = (const char *)SvPV_nolen(ST(1));
	int	port = (int)SvIV(ST(2));
	const char*	shost;
	int	sport;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_tcpip() - invalid session object");

	if (items < 4)
	    shost = NULL;
	else {
    shost = (const char *)SvPV_nolen(ST(3));
	}

	if (items < 5)
	    sport = 0;
	else {
	    sport = (int)SvIV(ST(4));
	}
#line 951 "SSH2.xs"
    if (!shost)
        shost = "127.0.0.1";
    if (!sport)
        sport = 22;
    NEW_CHANNEL(libssh2_channel_direct_tcpip_ex(ss->session,
     (char*)host, port, (char*)shost, sport));
#line 1744 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2_listen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_listen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::listen", "ss, port, host= NULL, bound_port= NULL, queue_maxsize= 16");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 964 "SSH2.xs"
    int i_bound_port;
#line 1778 "SSH2.c"
	SSH2_LISTENER *	RETVAL;
	SSH2*	ss;
	int	port = (int)SvIV(ST(1));
	const char*	host;
	SV*	bound_port;
	int	queue_maxsize;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_listen() - invalid session object");

	if (items < 3)
	    host = NULL;
	else {
    host = (const char *)SvPV_nolen(ST(2));
	}

	if (items < 4)
	    bound_port = NULL;
	else {
	    bound_port = ST(3);
	}

	if (items < 5)
	    queue_maxsize = 16;
	else {
	    queue_maxsize = (int)SvIV(ST(4));
	}
#line 966 "SSH2.xs"
    if (bound_port && SvOK(bound_port)) {
        if (!SvROK(bound_port) && SvTYPE(SvRV(bound_port)) <= SVt_PVNV)
            croak("%s::listen: bound port must be scalar reference");
    } else
        bound_port = NULL;
    NEW_LISTENER(libssh2_channel_forward_listen_ex(ss->session,
     (char*)host, port, bound_port ? &i_bound_port : NULL, queue_maxsize));
    if (RETVAL && bound_port)
        sv_setiv(SvRV(bound_port), i_bound_port);
#line 1818 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::Listener", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__poll); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__poll)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::_poll", "ss, timeout, event");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 981 "SSH2.xs"
    LIBSSH2_POLLFD* pollfd;
    int i, count, changed;
#line 1842 "SSH2.c"
	SSH2*	ss;
	int	timeout = (int)SvIV(ST(1));
	AV*	event;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__poll() - invalid session object");

    if(SvROK(ST(2)) && SvTYPE(SvRV(ST(2))) == SVt_PVAV)
        event = (AV*)SvRV(ST(2));
    else
        croak("event is not an array reference");
#line 984 "SSH2.xs"
    clear_error(ss);
    count = av_len(event) + 1;
    debug("%s::poll: timeout = %d, array[%d]\n", class, timeout, count);
    if (!count)  // some architectures return null for malloc(0)
        XSRETURN_IV(0);
    if (!(pollfd = Perl_malloc(sizeof(LIBSSH2_POLLFD) * count))) {
        set_error(ss, 0, "out of memory allocating pollfd structures");
        XSRETURN_EMPTY;
    }
    for (i = 0; i < count; ++i) {
        SV* sv = *av_fetch(event, i, 0/*lval*/), ** handle, ** events;
        HV* hv;

        if (!SvROK(sv) || SvTYPE(SvRV(sv)) != SVt_PVHV)
            croak("%s::poll: array element %d is not hash", class, i);
        hv = (HV*)SvRV(sv);

        if (!(handle = hv_fetch(hv, "handle", 6, 0/*lval*/)) || !*handle)
            croak("%s::poll: array element %d missing handle", class, i);
        if (sv_isobject(*handle)) {
            const char* package = HvNAME(SvSTASH(SvRV(*handle)));
            if (strEQ(package, "Net::SSH2::Channel")) {
                debug("- [%d] = channel\n", i);
                pollfd[i].type = LIBSSH2_POLLFD_CHANNEL;
                pollfd[i].fd.channel =
                 ((SSH2_CHANNEL*)SvIVX(GvSV((GV*)SvRV(*handle))))->channel;
            } else if(strEQ(package, "Net::SSH2::Listener")) {
                debug("- [%d] = listener\n", i);
                pollfd[i].type = LIBSSH2_POLLFD_LISTENER;
                pollfd[i].fd.listener =
                 ((SSH2_LISTENER*)SvIVX(SvRV(*handle)))->listener;
            } else {
                croak("%s::poll: invalid handle object in array (%d): %s",
                 class, package, i);
            }
        } else if(SvIOK(*handle)) {
            pollfd[i].type = LIBSSH2_POLLFD_SOCKET;
            pollfd[i].fd.socket = SvIV(*handle);
            debug("- [%d] = file(%d)\n", i, pollfd[i].fd.socket);
        } else {
            croak("%s::poll: invalid handle in array (%d): %s",
             class, i, SvPV_nolen(*handle));
        }

        events = hv_fetch(hv, "events", 6, 0/*lval*/);
        if (!events || !*events || !SvIOK(*events)) {
            croak("%s::poll: bad or missing event mask in array (%d)",
             class, i);
        }
        pollfd[i].events = SvIV(*events);
        pollfd[i].revents = 0;
        debug("- [%d] events %d\n", i, pollfd[i].events);
    }

    changed = libssh2_poll(pollfd, count, timeout);
    debug("- libssh2_poll returned %d\n", changed);

    if (changed < 0)
        count = 0;
    for (i = 0; i < count; ++i) {
        HV* hv = (HV*)SvRV(*av_fetch(event, i, 0/*lval*/));
        hv_store(hv, "revents", 7, newSViv(pollfd[i].revents), 0/*hash*/);
        debug("- [%d] revents %d\n", i, pollfd[i].revents);
    }

    Perl_mfree(pollfd);
    if (changed < 0)
        XSRETURN_EMPTY;
    XSRETURN_IV(changed);
#line 1926 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2_sftp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_sftp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::sftp", "ss");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_SFTP *	RETVAL;
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_sftp() - invalid session object");
#line 1057 "SSH2.xs"
    clear_error(ss);
    NEW_SFTP(libssh2_sftp_init(ss->session));
#line 1954 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::SFTP", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2_public_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2_public_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::public_key", "ss");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_PUBLICKEY *	RETVAL;
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_public_key() - invalid session object");
#line 1065 "SSH2.xs"
    clear_error(ss);
    NEW_PUBLICKEY(libssh2_publickey_init(ss->session));
#line 1985 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::PublicKey", (void *)RETVAL);

    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::Channel"

XS(XS_Net__SSH2__Channel_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::DESTROY", "ch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_DESTROY() - invalid channel object");
#line 1081 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(ch->ss);
    libssh2_channel_free(ch->channel);
    SvREFCNT_dec(ch->sv_ss);
    Safefree(ch);
#line 2020 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_session); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_session)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::session", "ch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_session() - invalid channel object");
#line 1090 "SSH2.xs"
    ST(0) = sv_2mortal(newRV_inc(ch->sv_ss));
    XSRETURN(1);
#line 2047 "SSH2.c"
    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__Channel_setenv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_setenv)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::setenv", "ch, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1096 "SSH2.xs"
    int i, success = 0;
    const char* pv_key, * pv_value;
    STRLEN len_key, len_value;
#line 2069 "SSH2.c"
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_setenv() - invalid channel object");
#line 1100 "SSH2.xs"
    clear_error(ch->ss);
    for (i = 1; i < items; i += 2) {
        if (i + 1 == items)
            croak("%s::setenv: key without value", class);
        pv_key = SvPV(ST(i), len_key);
        pv_value = SvPV(ST(i + 1), len_value);
        success += !libssh2_channel_setenv_ex(ch->channel,
         (char*)pv_key, len_key, (char*)pv_value, len_value);
    }
    XSRETURN_IV(success);
#line 2087 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_blocking); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_blocking)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::blocking", "ch, blocking");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;
	SV*	blocking = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_blocking() - invalid channel object");
#line 1114 "SSH2.xs"
    clear_error(ch->ss);
    libssh2_channel_set_blocking(ch->channel, SvTRUE(blocking));
    XSRETURN_IV(1);
#line 2116 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_eof); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_eof)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::eof", "ch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_eof() - invalid channel object");
#line 1121 "SSH2.xs"
   clear_error(ch->ss);
   XSRETURN_IV(libssh2_channel_eof(ch->channel));
#line 2143 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_send_eof); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_send_eof)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::send_eof", "ch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_send_eof() - invalid channel object");
#line 1127 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(!libssh2_channel_send_eof(ch->channel));
#line 2170 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::close", "ch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_close() - invalid channel object");
#line 1133 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(!libssh2_channel_close(ch->channel));
#line 2197 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_wait_closed); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_wait_closed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::wait_closed", "ch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_wait_closed() - invalid channel object");
#line 1139 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(!libssh2_channel_wait_closed(ch->channel));
#line 2224 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_exit_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_exit_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::exit_status", "ch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_exit_status() - invalid channel object");
#line 1145 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(libssh2_channel_get_exit_status(ch->channel));
#line 2251 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_pty); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_pty)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::pty", "ch, terminal, modes= NULL, width= 0, height= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1152 "SSH2.xs"
    const char* pv_terminal, * pv_modes = NULL;
    STRLEN len_terminal, len_modes = 0;
    int width_px = LIBSSH2_TERM_WIDTH_PX, height_px = LIBSSH2_TERM_HEIGHT_PX;
#line 2273 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	terminal = ST(1);
	SV*	modes;
	int	width;
	int	height;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_pty() - invalid channel object");

	if (items < 3)
	    modes = NULL;
	else {
	    modes = ST(2);
	}

	if (items < 4)
	    width = 0;
	else {
	    width = (int)SvIV(ST(3));
	}

	if (items < 5)
	    height = 0;
	else {
	    height = (int)SvIV(ST(4));
	}
#line 1156 "SSH2.xs"
    pv_terminal = SvPV(terminal, len_terminal);
    if (modes && SvPOK(modes))
        pv_modes = SvPV(modes, len_modes);

    if (!width)
        width = LIBSSH2_TERM_WIDTH;
    else if(width < 0) {
        width_px = -width;
        width = 0;
    }

    if (!height)
        height = LIBSSH2_TERM_HEIGHT;
    else if(height < 0) {
        height_px = -height;
        height = 0;
    }

    XSRETURN_IV(!libssh2_channel_request_pty_ex(ch->channel,
     (char*)pv_terminal, len_terminal, (char*)pv_modes, len_modes,
     width, height, width_px, height_px));
#line 2324 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_process); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_process)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::process", "ch, request, message= NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1181 "SSH2.xs"
    const char* pv_request, * pv_message = NULL;
    STRLEN len_request, len_message = 0;
#line 2345 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	request = ST(1);
	SV*	message;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_process() - invalid channel object");

	if (items < 3)
	    message = NULL;
	else {
	    message = ST(2);
	}
#line 1184 "SSH2.xs"
    pv_request = SvPV(request, len_request);
    if (message && SvPOK(message))
        pv_message = SvPV(message, len_message);

    XSRETURN_IV(!libssh2_channel_process_startup(ch->channel,
     pv_request, len_request, pv_message, len_message));
#line 2367 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_ext_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_ext_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::ext_data", "ch, mode");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1194 "SSH2.xs"
    IV i_mode;
#line 2387 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	mode = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_ext_data() - invalid channel object");
#line 1196 "SSH2.xs"
    if (!iv_constant_sv("LIBSSH2_CHANNEL_EXTENDED_DATA_", mode, &i_mode))
        croak("%s::ext_data: unknown extended data mode: %s",
         class, SvPV_nolen(mode));
    libssh2_channel_handle_extended_data(ch->channel, i_mode);
    XSRETURN_IV(1);
#line 2401 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_read)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::read", "ch, buffer, size, ext= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1205 "SSH2.xs"
    char* pv_buffer;
    int count, total = 0;
#line 2422 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	buffer = ST(1);
	size_t	size = (size_t)SvUV(ST(2));
	int	ext;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_read() - invalid channel object");

	if (items < 4)
	    ext = 0;
	else {
	    ext = (int)SvIV(ST(3));
	}
#line 1208 "SSH2.xs"
    debug("%s::read(size = %d, ext = %d)\n", class, size, ext);
    clear_error(ch->ss);
    SvPOK_on(buffer);
    pv_buffer = sv_grow(buffer, size + 1/*NUL*/);  /* force PV */

    again:
    count = libssh2_channel_read_ex(ch->channel, XLATEXT, pv_buffer, size);
    debug("- read %d bytes\n", count);

    if (count < 0) {
        if (!total) {
            SvCUR_set(buffer, 0);
            XSRETURN_EMPTY;
        }
        count = 0;
    }

    total += count;
    if (count > 0 && (unsigned)count < size) {
        pv_buffer += count;
        size -= count;
        goto again;
    }

    pv_buffer[count] = '\0';
    SvCUR_set(buffer, total);
    debug("- read %d total\n", total);
    XSRETURN_IV(total);
#line 2467 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_write); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_write)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::write", "ch, buffer, ext= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1240 "SSH2.xs"
    const char* pv_buffer;
    STRLEN len_buffer;
    int count;
#line 2489 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	buffer = ST(1);
	int	ext;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_write() - invalid channel object");

	if (items < 3)
	    ext = 0;
	else {
	    ext = (int)SvIV(ST(2));
	}
#line 1244 "SSH2.xs"
    clear_error(ch->ss);
    pv_buffer = SvPV(buffer, len_buffer);
    count = libssh2_channel_write_ex(ch->channel, XLATEXT,
     pv_buffer, len_buffer);
    if (count < 0)
        XSRETURN_EMPTY;
    XSRETURN_IV(count);
#line 2512 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Channel_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Channel_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Channel::flush", "ch, ext= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1255 "SSH2.xs"
    int count;
#line 2532 "SSH2.c"
	SSH2_CHANNEL*	ch;
	int	ext;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_flush() - invalid channel object");

	if (items < 2)
	    ext = 0;
	else {
	    ext = (int)SvIV(ST(1));
	}
#line 1257 "SSH2.xs"
    clear_error(ch->ss);
    count = libssh2_channel_flush_ex(ch->channel, XLATEXT);
    if (count < 0)
        XSRETURN_EMPTY;
    XSRETURN_IV(count);
#line 2552 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#undef class
#define class "Net::SSH2::Listener"

XS(XS_Net__SSH2__Listener_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Listener_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Listener::DESTROY", "ls");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_LISTENER*	ls;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ls = (SSH2_LISTENER *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Listener::net_ls_DESTROY() - invalid listener object");
#line 1274 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(ls->ss);
    libssh2_channel_forward_cancel(ls->listener);
    SvREFCNT_dec(ls->sv_ss);
    Safefree(ls);
#line 2584 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Listener_accept); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Listener_accept)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Listener::accept", "ls");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1283 "SSH2.xs"
    SSH2* ss;
#line 2604 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2_LISTENER*	ls;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ls = (SSH2_LISTENER *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Listener::net_ls_accept() - invalid listener object");
#line 1285 "SSH2.xs"
    clear_error(ss = ls->ss);
    NEW_CHANNEL(libssh2_channel_forward_accept(ls->listener));
#line 2615 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }

    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::SFTP"

XS(XS_Net__SSH2__SFTP_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::DESTROY", "sf");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_SFTP*	sf;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_DESTROY() - invalid SFTP object");
#line 1301 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(sf->ss);
    libssh2_sftp_shutdown(sf->sftp);
    debug("%s::DESTROY freeing session\n");
    SvREFCNT_dec(sf->sv_ss);
    Safefree(sf);
#line 2662 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__SFTP_session); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_session)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::session", "sf");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_SFTP*	sf;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_session() - invalid SFTP object");
#line 1311 "SSH2.xs"
    ST(0) = sv_2mortal(newRV_inc(sf->sv_ss));
    XSRETURN(1);
#line 2689 "SSH2.c"
    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__SFTP_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::error", "sf");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1317 "SSH2.xs"
    unsigned long error;
#line 2709 "SSH2.c"
	SSH2_SFTP*	sf;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_error() - invalid SFTP object");
#line 1319 "SSH2.xs"
    error = libssh2_sftp_last_error(sf->sftp);
    switch (GIMME_V) {
    case G_SCALAR:
        XSRETURN_UV(error);
    case G_ARRAY:
        EXTEND(SP, 2);
        ST(0) = sv_2mortal(newSVuv(error));
        if (error >= 0 && error < countof(sftp_error))
            ST(1) = sv_2mortal(newSVpvf("SSH_FX_%s", sftp_error[error]));
        else
            ST(1) = sv_2mortal(newSVpvf("SSH_FX_UNKNOWN(%d)", error));
        XSRETURN(2);
    }
#line 2730 "SSH2.c"
    }
    XSRETURN(1);
}

#define XLATFLAG(posix, fxf) do { \
    if (flags & posix || \
     l_flags == 0 && posix == 0 && flags == posix /* 0-valued flag */) { \
        l_flags |= fxf; \
        flags &= ~posix; \
    } \
} while(0)

XS(XS_Net__SSH2__SFTP_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::open", "sf, file, flags= O_RDONLY, mode= 0666");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1344 "SSH2.xs"
    long l_flags = 0;
    const char* pv_file;
    STRLEN len_file;
#line 2759 "SSH2.c"
	SSH2_FILE *	RETVAL;
	SSH2_SFTP*	sf;
	SV*	file = ST(1);
	int	flags;
	int	mode;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_open() - invalid SFTP object");

	if (items < 3)
	    flags = O_RDONLY;
	else {
	    flags = (int)SvIV(ST(2));
	}

	if (items < 4)
	    mode = 0666;
	else {
	    mode = (int)SvIV(ST(3));
	}
#line 1348 "SSH2.xs"
    clear_error(sf->ss);
    pv_file = SvPV(file, len_file);

    /* map POSIX O_* to LIBSSH2_FXF_* (can't assume they're the same) */
    XLATFLAG(O_RDWR,   LIBSSH2_FXF_READ | LIBSSH2_FXF_WRITE);
    XLATFLAG(O_RDONLY, LIBSSH2_FXF_READ);
    XLATFLAG(O_WRONLY, LIBSSH2_FXF_WRITE);
    XLATFLAG(O_APPEND, LIBSSH2_FXF_APPEND);
    XLATFLAG(O_CREAT,  LIBSSH2_FXF_CREAT);
    XLATFLAG(O_TRUNC,  LIBSSH2_FXF_TRUNC);
    XLATFLAG(O_EXCL,   LIBSSH2_FXF_EXCL);
    if (flags)
        croak("%s::open: unknown flag value: %d", class, flags);

    NEW_FILE(libssh2_sftp_open_ex(sf->sftp, (char*)pv_file, len_file,
     l_flags, mode, LIBSSH2_SFTP_OPENFILE));
#line 2799 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::File");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_fi_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::File", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }

    }
    XSRETURN(1);
}

#undef XLATFLAG

XS(XS_Net__SSH2__SFTP_opendir); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_opendir)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::opendir", "sf, dir");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1372 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 2835 "SSH2.c"
	SSH2_DIR *	RETVAL;
	SSH2_SFTP*	sf;
	SV*	dir = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_opendir() - invalid SFTP object");
#line 1375 "SSH2.xs"
    clear_error(sf->ss);
    pv_dir = SvPV(dir, len_dir);
    NEW_DIR(libssh2_sftp_open_ex(sf->sftp, (char*)pv_dir, len_dir,
     0/*flags*/, 0/*mode*/, LIBSSH2_SFTP_OPENDIR));
#line 2849 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::Dir", (void *)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__SFTP_unlink); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_unlink)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::unlink", "sf, file");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1385 "SSH2.xs"
    const char* pv_file;
    STRLEN len_file;
#line 2873 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	file = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_unlink() - invalid SFTP object");
#line 1388 "SSH2.xs"
    clear_error(sf->ss);
    pv_file = SvPV(file, len_file);
    XSRETURN_IV(!libssh2_sftp_unlink_ex(sf->sftp, (char*)pv_file, len_file));
#line 2885 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__SFTP_rename); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_rename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::rename", "sf, old, new, flags= LIBSSH2_SFTP_RENAME_OVERWRITE |  LIBSSH2_SFTP_RENAME_ATOMIC | LIBSSH2_SFTP_RENAME_NATIVE");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1397 "SSH2.xs"
    const char* pv_old, * pv_new;
    STRLEN len_old, len_new;
#line 2906 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	old = ST(1);
	SV*	new = ST(2);
	long	flags;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_rename() - invalid SFTP object");

	if (items < 4)
	    flags = LIBSSH2_SFTP_RENAME_OVERWRITE |  LIBSSH2_SFTP_RENAME_ATOMIC | LIBSSH2_SFTP_RENAME_NATIVE;
	else {
	    flags = (long)SvIV(ST(3));
	}
#line 1400 "SSH2.xs"
    clear_error(sf->ss);
    pv_old = SvPV(old, len_old);
    pv_new = SvPV(new, len_new);
    XSRETURN_IV(!libssh2_sftp_rename_ex(sf->sftp,
     (char*)pv_old, len_old, (char*)pv_new, len_new, flags));
#line 2928 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__SFTP_mkdir); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_mkdir)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::mkdir", "sf, dir, mode= 0777");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1409 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 2949 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	dir = ST(1);
	int	mode;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_mkdir() - invalid SFTP object");

	if (items < 3)
	    mode = 0777;
	else {
	    mode = (int)SvIV(ST(2));
	}
#line 1412 "SSH2.xs"
    clear_error(sf->ss);
    pv_dir = SvPV(dir, len_dir);
    XSRETURN_IV(!libssh2_sftp_mkdir_ex(sf->sftp, (char*)pv_dir, len_dir, mode));
#line 2968 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__SFTP_rmdir); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_rmdir)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::rmdir", "sf, dir");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1419 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 2989 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	dir = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_rmdir() - invalid SFTP object");
#line 1422 "SSH2.xs"
    clear_error(sf->ss);
    pv_dir = SvPV(dir, len_dir);
    XSRETURN_IV(!libssh2_sftp_rmdir_ex(sf->sftp, (char*)pv_dir, len_dir));
#line 3001 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__SFTP_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::stat", "sf, path, follow= 1");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1429 "SSH2.xs"
    const char* pv_path;
    STRLEN len_path;
    int success;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 3026 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1);
	int	follow;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_stat() - invalid SFTP object");

	if (items < 3)
	    follow = 1;
	else {
	    follow = (int)SvIV(ST(2));
	}
#line 1434 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    success = !libssh2_sftp_stat_ex(sf->sftp, (char*)pv_path, len_path,
     follow ? LIBSSH2_SFTP_STAT : LIBSSH2_SFTP_LSTAT, &attrs);
    if (!success)
        XSRETURN_EMPTY;
    XSRETURN_STAT_ATTRS(SvREFCNT_inc(path));
#line 3049 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__SSH2__SFTP_setstat); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_setstat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::setstat", "sf, path, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1445 "SSH2.xs"
    const char* pv_path;
    STRLEN len_path;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
    int i;
#line 3073 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_setstat() - invalid SFTP object");
#line 1450 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    Zero(&attrs, 1, LIBSSH2_SFTP_ATTRIBUTES);

    /* read key/value pairs; cf. hv_from_attrs */
    for (i = 2; i < items; i += 2) {
        const char* key = SvPV_nolen(ST(i));
        if (i + 1 == items)
            croak("%s::setstat: key without value", class);
        if (0);  /* prime the chain */
        XLATATTR("size",  filesize,    SIZE)
        XLATATTR("uid",   uid,         UIDGID)
        XLATATTR("gid",   gid,         UIDGID)
        XLATATTR("mode",  permissions, PERMISSIONS)
        XLATATTR("atime", atime,       ACMODTIME)
        XLATATTR("mtime", mtime,       ACMODTIME)
        else
            croak("%s::setstat: unknown attribute: %s", class, key);
    }

    XSRETURN_IV(!libssh2_sftp_stat_ex(sf->sftp, (char*)pv_path, len_path,
     LIBSSH2_SFTP_SETSTAT, &attrs));
#line 3104 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__SFTP_symlink); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_symlink)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::symlink", "sf, path, target");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1476 "SSH2.xs"
    const char* pv_path, * pv_target;
    STRLEN len_path, len_target;
#line 3125 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1);
	SV*	target = ST(2);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_symlink() - invalid SFTP object");
#line 1479 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    pv_target = SvPV(target, len_target);
    XSRETURN_IV(!libssh2_sftp_symlink_ex(sf->sftp,
     pv_path, len_path, (char*)pv_target, len_target, LIBSSH2_SFTP_SYMLINK));
#line 3140 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__SFTP_readlink); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_readlink)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::readlink", "sf, path");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1488 "SSH2.xs"
    SV* link;
    const char* pv_path;
    char* pv_link;
    STRLEN len_path;
    int count;
#line 3164 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_readlink() - invalid SFTP object");
#line 1494 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    link = newSV(MAXPATHLEN + 1);
    SvPOK_on(link);
    pv_link = SvPVX(link);

    count = libssh2_sftp_symlink_ex(sf->sftp,
     pv_path, len_path, pv_link, MAXPATHLEN, LIBSSH2_SFTP_READLINK);

    if (count < 0) {
        SvREFCNT_dec(link);
        XSRETURN_EMPTY;
    }
    pv_link[count] = '\0';
    SvCUR_set(link, count);
    ST(0) = sv_2mortal(link);
    XSRETURN(1);
#line 3190 "SSH2.c"
    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__SFTP_realpath); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__SFTP_realpath)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::SFTP::realpath", "sf, path");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1515 "SSH2.xs"
    SV* real;
    const char* pv_path;
    char* pv_real;
    STRLEN len_path;
    int count;
#line 3214 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_realpath() - invalid SFTP object");
#line 1521 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    real = newSV(MAXPATHLEN + 1);
    SvPOK_on(real);
    pv_real = SvPVX(real);

    count = libssh2_sftp_symlink_ex(sf->sftp,
     pv_path, len_path, pv_real, MAXPATHLEN, LIBSSH2_SFTP_REALPATH);

    if (count < 0) {
        SvREFCNT_dec(real);
        XSRETURN_EMPTY;
    }
    pv_real[count] = '\0';
    SvCUR_set(real, count);
    ST(0) = sv_2mortal(real);
    XSRETURN(1);
#line 3240 "SSH2.c"
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::File"

XS(XS_Net__SSH2__File_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__File_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::File::DESTROY", "fi");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_DESTROY() - invalid SFTP file object");
#line 1550 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(fi->sf->ss);
    libssh2_sftp_close_handle(fi->handle);
    SvREFCNT_dec(fi->sv_sf);
    Safefree(fi);
#line 3272 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__File_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__File_read)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::File::read", "fi, buffer, size");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1559 "SSH2.xs"
    char* pv_buffer;
    int count;
#line 3293 "SSH2.c"
	SSH2_FILE*	fi;
	SV*	buffer = ST(1);
	size_t	size = (size_t)SvUV(ST(2));

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_read() - invalid SFTP file object");
#line 1562 "SSH2.xs"
    clear_error(fi->sf->ss);
    SvPOK_on(buffer);
    pv_buffer = sv_grow(buffer, size + 1/*NUL*/);  /* force PV */
    pv_buffer[size] = '\0';

    count = libssh2_sftp_read(fi->handle, pv_buffer, size);
    if (count < 0) {
        SvCUR_set(buffer, 0);
        XSRETURN_EMPTY;
    }
    SvCUR_set(buffer, count);
    XSRETURN_IV(count);
#line 3315 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__File_write); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__File_write)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::File::write", "fi, buffer");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1578 "SSH2.xs"
    const char* pv_buffer;
    STRLEN len_buffer;
    size_t count;
#line 3337 "SSH2.c"
	SSH2_FILE*	fi;
	SV*	buffer = ST(1);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_write() - invalid SFTP file object");
#line 1582 "SSH2.xs"
    clear_error(fi->sf->ss);
    pv_buffer = SvPV(buffer, len_buffer);
    count = libssh2_sftp_write(fi->handle, pv_buffer, len_buffer);
    if (count < 0)
        XSRETURN_EMPTY;
    XSRETURN_UV(count);    
#line 3352 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__File_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__File_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::File::stat", "fi");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1592 "SSH2.xs"
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 3374 "SSH2.c"
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_stat() - invalid SFTP file object");
#line 1594 "SSH2.xs"
    clear_error(fi->sf->ss);
    if (libssh2_sftp_fstat(fi->handle, &attrs))
        XSRETURN_EMPTY;
    XSRETURN_STAT_ATTRS(NULL/*name*/);
#line 3386 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__SSH2__File_setstat); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__File_setstat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::File::setstat", "fi, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1602 "SSH2.xs"
    LIBSSH2_SFTP_ATTRIBUTES attrs;
    int i;
#line 3408 "SSH2.c"
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_setstat() - invalid SFTP file object");
#line 1605 "SSH2.xs"
    clear_error(fi->sf->ss);
    Zero(&attrs, 1, LIBSSH2_SFTP_ATTRIBUTES);

    /* read key/value pairs; cf. hv_from_attrs */
    for (i = 1; i < items; i += 2) {
        const char* key = SvPV_nolen(ST(i));
        if (i + 1 == items)
            croak("%s::setstat: key without value", class);
        if (0);  /* prime the chain */
        XLATATTR("size",  filesize,    SIZE)
        XLATATTR("uid",   uid,         UIDGID)
        XLATATTR("gid",   gid,         UIDGID)
        XLATATTR("mode",  permissions, PERMISSIONS)
        XLATATTR("atime", atime,       ACMODTIME)
        XLATATTR("mtime", mtime,       ACMODTIME)
        else
            croak("%s::setstat: unknown attribute: %s", class, key);
    }

    XSRETURN_IV(!libssh2_sftp_fsetstat(fi->handle, &attrs));
#line 3436 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__File_seek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__File_seek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::File::seek", "fi, offset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_FILE*	fi;
	size_t	offset = (size_t)SvUV(ST(1));

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_seek() - invalid SFTP file object");
#line 1629 "SSH2.xs"
    clear_error(fi->sf->ss);
    libssh2_sftp_seek(fi->handle, offset);
    XSRETURN(1);
#line 3465 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__File_tell); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__File_tell)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::File::tell", "fi");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_tell() - invalid SFTP file object");
#line 1636 "SSH2.xs"
    clear_error(fi->sf->ss);
    XSRETURN_UV(libssh2_sftp_tell(fi->handle));
#line 3492 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#undef class
#define class "Net::SSH2::Dir"

XS(XS_Net__SSH2__Dir_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Dir_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Dir::DESTROY", "di");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_DIR*	di;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        di = (SSH2_DIR *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Dir::net_di_DESTROY() - invalid SFTP directory object");
#line 1650 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(di->sf->ss);
    libssh2_sftp_close_handle(di->handle);
    SvREFCNT_dec(di->sv_sf);
    Safefree(di);
#line 3524 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__Dir_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__Dir_read)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::Dir::read", "di");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1659 "SSH2.xs"
    SV* buffer;
    char* pv_buffer;
    int count;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 3549 "SSH2.c"
	SSH2_DIR*	di;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        di = (SSH2_DIR *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Dir::net_di_read() - invalid SFTP directory object");
#line 1664 "SSH2.xs"
    clear_error(di->sf->ss);
    buffer = newSV(MAXPATHLEN + 1);
    SvPOK_on(buffer);
    pv_buffer = SvPVX(buffer);

    count = libssh2_sftp_readdir(di->handle, pv_buffer, MAXPATHLEN, &attrs);

    if (count <= 0) {
        SvREFCNT_dec(buffer);
        XSRETURN_EMPTY;
    }
    pv_buffer[count] = '\0';
    SvCUR_set(buffer, count);
    XSRETURN_STAT_ATTRS(buffer);
#line 3571 "SSH2.c"
	PUTBACK;
	return;
    }
}

#undef class
#define class "Net::SSH2::PublicKey"

XS(XS_Net__SSH2__PublicKey_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__PublicKey_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::PublicKey::DESTROY", "pk");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SSH2_PUBLICKEY*	pk;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_DESTROY() - invalid public key object");
#line 1690 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(pk->ss);
    libssh2_publickey_shutdown(pk->pkey);
    SvREFCNT_dec(pk->sv_ss);
    Safefree(pk);
#line 3604 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__PublicKey_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__PublicKey_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::PublicKey::add", "pk, name, blob, overwrite, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1699 "SSH2.xs"
    int success;
    const char* pv_name, * pv_blob;
    STRLEN len_name, len_blob;
    unsigned long num_attrs, i;
    libssh2_publickey_attribute *attrs;
#line 3628 "SSH2.c"
	SSH2_PUBLICKEY*	pk;
	SV*	name = ST(1);
	SV*	blob = ST(2);
	int	overwrite = (int)SvIV(ST(3));

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_add() - invalid public key object");
#line 1705 "SSH2.xs"
    clear_error(pk->ss);
    pv_name = SvPV(name, len_name);
    pv_blob = SvPV(blob, len_blob);

    num_attrs = items - 4;
    if (!(attrs = Perl_malloc(sizeof(*attrs) * num_attrs))) {
        set_error(pk->ss, 0, "out of memory allocating attribute structures");
        XSRETURN_EMPTY;
    }
    for (i = 0; i < num_attrs; ++i) {
        HV* hv;
        SV** tmp;
        STRLEN len_tmp;

        if (!SvROK(ST(i + 4)) || SvTYPE(SvRV(ST(i + 4))) != SVt_PVHV)
            croak("%s::add: attribute %d is not hash", class, i);
        hv = (HV*)SvRV(ST(i + 4));

        if (!(tmp = hv_fetch(hv, "name", 4, 0/*lval*/)) || !*tmp)
            croak("%s::add: attribute %d missing name", class, i);
        attrs[i].name = SvPV(*tmp, len_tmp);
        attrs[i].name_len = len_tmp;

        if ((tmp = hv_fetch(hv, "value", 5, 0/*lval*/)) && *tmp) {
            attrs[i].value = SvPV(*tmp, len_tmp);
            attrs[i].value_len = len_tmp;
        } else
            attrs[i].value_len = 0;

        if ((tmp = hv_fetch(hv, "mandatory", 9, 0/*lval*/)) && *tmp)
            attrs[i].mandatory = (char)SvIV(*tmp);
        else
            attrs[i].mandatory = 0;
    }

    success = !libssh2_publickey_add_ex(pk->pkey,
     pv_name, len_name, pv_blob, len_blob, overwrite, num_attrs, attrs);

    Perl_mfree(attrs);
    XSRETURN_IV(!success);
#line 3679 "SSH2.c"
    }
    XSRETURN(1);
}


XS(XS_Net__SSH2__PublicKey_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__PublicKey_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::PublicKey::remove", "pk, name, blob");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1749 "SSH2.xs"
    const char* pv_name, * pv_blob;
    STRLEN len_name, len_blob;
#line 3700 "SSH2.c"
	SSH2_PUBLICKEY*	pk;
	SV*	name = ST(1);
	SV*	blob = ST(2);

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_remove() - invalid public key object");
#line 1752 "SSH2.xs"
    clear_error(pk->ss);
    pv_name = SvPV(name, len_name);
    pv_blob = SvPV(blob, len_blob);
    XSRETURN_IV(!libssh2_publickey_remove_ex(pk->pkey,
     pv_name, len_name, pv_blob, len_blob));
#line 3715 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__SSH2__PublicKey_fetch); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__SSH2__PublicKey_fetch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::SSH2::PublicKey::fetch", "pk");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1761 "SSH2.xs"
    unsigned long keys, i, j;
    libssh2_publickey_list* list = NULL;
#line 3738 "SSH2.c"
	SSH2_PUBLICKEY*	pk;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_fetch() - invalid public key object");
#line 1764 "SSH2.xs"
    if (!libssh2_publickey_list_fetch(pk->pkey, &keys, &list) || !list)
        XSRETURN_EMPTY;

    if (GIMME_V == G_ARRAY) {
        EXTEND(SP, keys);

        for (i = 0; i < keys; ++i) {
            HV* hv = newHV();
            AV* av = newAV();

            hv_store(hv, "name", 4,
             newSVpvn((char*)list[i].name, list[i].name_len), 0/*hash*/);
            hv_store(hv, "blob", 4,
             newSVpvn((char*)list[i].blob, list[i].blob_len), 0/*hash*/);

            hv_store(hv, "attr", 4, newRV_noinc((SV*)av), 0/*hash*/);
            av_extend(av, list[i].num_attrs - 1);
            for (j = 0; j < list[i].num_attrs; ++j) {
                HV* attr = newHV();
                hv_store(attr, "name", 4, newSVpvn(list[i].attrs[j].name,
                 list[i].attrs[j].name_len), 0/*hash*/);
                hv_store(attr, "value", 5, newSVpvn(list[i].attrs[j].value,
                 list[i].attrs[j].value_len), 0/*hash*/);
                hv_store(attr, "mandatory", 9,
                 newSViv(list[i].attrs[j].mandatory), 0/*hash*/);
                av_store(av, j, newRV_noinc((SV*)attr));
            }

            ST(i) = sv_2mortal(newRV_noinc((SV*)hv));
        }
    }

    libssh2_publickey_list_free(pk->pkey, list);

    if (GIMME_V == G_ARRAY)
        XSRETURN(keys);
    XSRETURN_UV(keys);
#line 3783 "SSH2.c"
	PUTBACK;
	return;
    }
}

#undef class
#ifdef __cplusplus
extern "C"
#endif
XS(boot_Net__SSH2); /* prototype to pass -Wmissing-prototypes */
XS(boot_Net__SSH2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Net::SSH2::constant", XS_Net__SSH2_constant, file);
        newXS("Net::SSH2::new", XS_Net__SSH2_new, file);
        newXS("Net::SSH2::blocking", XS_Net__SSH2_blocking, file);
        newXS("Net::SSH2::DESTROY", XS_Net__SSH2_DESTROY, file);
        newXS("Net::SSH2::debug", XS_Net__SSH2_debug, file);
        newXS("Net::SSH2::version", XS_Net__SSH2_version, file);
        newXS("Net::SSH2::banner", XS_Net__SSH2_banner, file);
        newXS("Net::SSH2::error", XS_Net__SSH2_error, file);
        newXS("Net::SSH2::method", XS_Net__SSH2_method, file);
        newXS("Net::SSH2::callback", XS_Net__SSH2_callback, file);
        newXS("Net::SSH2::_startup", XS_Net__SSH2__startup, file);
        newXS("Net::SSH2::disconnect", XS_Net__SSH2_disconnect, file);
        newXS("Net::SSH2::hostkey", XS_Net__SSH2_hostkey, file);
        newXS("Net::SSH2::auth_list", XS_Net__SSH2_auth_list, file);
        newXS("Net::SSH2::auth_ok", XS_Net__SSH2_auth_ok, file);
        newXS("Net::SSH2::auth_password", XS_Net__SSH2_auth_password, file);
        newXS("Net::SSH2::auth_publickey", XS_Net__SSH2_auth_publickey, file);
        newXS("Net::SSH2::auth_hostbased", XS_Net__SSH2_auth_hostbased, file);
        newXS("Net::SSH2::auth_keyboard", XS_Net__SSH2_auth_keyboard, file);
        newXS("Net::SSH2::channel", XS_Net__SSH2_channel, file);
        newXS("Net::SSH2::_scp_get", XS_Net__SSH2__scp_get, file);
        newXS("Net::SSH2::_scp_put", XS_Net__SSH2__scp_put, file);
        newXS("Net::SSH2::tcpip", XS_Net__SSH2_tcpip, file);
        newXS("Net::SSH2::listen", XS_Net__SSH2_listen, file);
        newXS("Net::SSH2::_poll", XS_Net__SSH2__poll, file);
        newXS("Net::SSH2::sftp", XS_Net__SSH2_sftp, file);
        newXS("Net::SSH2::public_key", XS_Net__SSH2_public_key, file);
        newXS("Net::SSH2::Channel::DESTROY", XS_Net__SSH2__Channel_DESTROY, file);
        newXS("Net::SSH2::Channel::session", XS_Net__SSH2__Channel_session, file);
        newXS("Net::SSH2::Channel::setenv", XS_Net__SSH2__Channel_setenv, file);
        newXS("Net::SSH2::Channel::blocking", XS_Net__SSH2__Channel_blocking, file);
        newXS("Net::SSH2::Channel::eof", XS_Net__SSH2__Channel_eof, file);
        newXS("Net::SSH2::Channel::send_eof", XS_Net__SSH2__Channel_send_eof, file);
        newXS("Net::SSH2::Channel::close", XS_Net__SSH2__Channel_close, file);
        newXS("Net::SSH2::Channel::wait_closed", XS_Net__SSH2__Channel_wait_closed, file);
        newXS("Net::SSH2::Channel::exit_status", XS_Net__SSH2__Channel_exit_status, file);
        newXS("Net::SSH2::Channel::pty", XS_Net__SSH2__Channel_pty, file);
        newXS("Net::SSH2::Channel::process", XS_Net__SSH2__Channel_process, file);
        newXS("Net::SSH2::Channel::ext_data", XS_Net__SSH2__Channel_ext_data, file);
        newXS("Net::SSH2::Channel::read", XS_Net__SSH2__Channel_read, file);
        newXS("Net::SSH2::Channel::write", XS_Net__SSH2__Channel_write, file);
        newXS("Net::SSH2::Channel::flush", XS_Net__SSH2__Channel_flush, file);
        newXS("Net::SSH2::Listener::DESTROY", XS_Net__SSH2__Listener_DESTROY, file);
        newXS("Net::SSH2::Listener::accept", XS_Net__SSH2__Listener_accept, file);
        newXS("Net::SSH2::SFTP::DESTROY", XS_Net__SSH2__SFTP_DESTROY, file);
        newXS("Net::SSH2::SFTP::session", XS_Net__SSH2__SFTP_session, file);
        newXS("Net::SSH2::SFTP::error", XS_Net__SSH2__SFTP_error, file);
        newXS("Net::SSH2::SFTP::open", XS_Net__SSH2__SFTP_open, file);
        newXS("Net::SSH2::SFTP::opendir", XS_Net__SSH2__SFTP_opendir, file);
        newXS("Net::SSH2::SFTP::unlink", XS_Net__SSH2__SFTP_unlink, file);
        newXS("Net::SSH2::SFTP::rename", XS_Net__SSH2__SFTP_rename, file);
        newXS("Net::SSH2::SFTP::mkdir", XS_Net__SSH2__SFTP_mkdir, file);
        newXS("Net::SSH2::SFTP::rmdir", XS_Net__SSH2__SFTP_rmdir, file);
        newXS("Net::SSH2::SFTP::stat", XS_Net__SSH2__SFTP_stat, file);
        newXS("Net::SSH2::SFTP::setstat", XS_Net__SSH2__SFTP_setstat, file);
        newXS("Net::SSH2::SFTP::symlink", XS_Net__SSH2__SFTP_symlink, file);
        newXS("Net::SSH2::SFTP::readlink", XS_Net__SSH2__SFTP_readlink, file);
        newXS("Net::SSH2::SFTP::realpath", XS_Net__SSH2__SFTP_realpath, file);
        newXS("Net::SSH2::File::DESTROY", XS_Net__SSH2__File_DESTROY, file);
        newXS("Net::SSH2::File::read", XS_Net__SSH2__File_read, file);
        newXS("Net::SSH2::File::write", XS_Net__SSH2__File_write, file);
        newXS("Net::SSH2::File::stat", XS_Net__SSH2__File_stat, file);
        newXS("Net::SSH2::File::setstat", XS_Net__SSH2__File_setstat, file);
        newXS("Net::SSH2::File::seek", XS_Net__SSH2__File_seek, file);
        newXS("Net::SSH2::File::tell", XS_Net__SSH2__File_tell, file);
        newXS("Net::SSH2::Dir::DESTROY", XS_Net__SSH2__Dir_DESTROY, file);
        newXS("Net::SSH2::Dir::read", XS_Net__SSH2__Dir_read, file);
        newXS("Net::SSH2::PublicKey::DESTROY", XS_Net__SSH2__PublicKey_DESTROY, file);
        newXS("Net::SSH2::PublicKey::add", XS_Net__SSH2__PublicKey_add, file);
        newXS("Net::SSH2::PublicKey::remove", XS_Net__SSH2__PublicKey_remove, file);
        newXS("Net::SSH2::PublicKey::fetch", XS_Net__SSH2__PublicKey_fetch, file);
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

